<script>
import Vue from 'vue';
import { IsMobileMixin } from '../../../mixins';
import TypingAnimation from './code-editor/typing-animation.vue';
import HeaderLogo from './header-logo.vue';

export default Vue.extend({
  components: {
    HeaderLogo,
    TypingAnimation,
  },
  mixins: [IsMobileMixin],
  props: {
    note: {
      type: String,
      required: true,
    },
    header: {
      type: String,
      required: false,
      default: '',
    },
    description: {
      type: Array,
      required: true,
    },
    image: {
      type: Object,
      required: true,
    },
    button: {
      type: Object,
      required: false,
      default: null,
    },
    secondaryButton: {
      type: Object,
      required: false,
      default: null,
    },
  },
  data() {
    return {
      textArrayIndex: 0,
      highlightedText: 'secure',
      typingDelay: 30,
      newLineDelay: 0,
      charIndex: 0,
      typedText: '',
      isTyping: false,
      timeout: null,
      isFinished: false,
      carouselIndex: 0,
    };
  },
  computed: {
    selectedDescription() {
      return this.description[this.carouselIndex];
    },
  },
  methods: {
    switchTypedContent() {
      // Wait for the next tick for Vue to update the DOM
      this.$nextTick(() => {
        // Loop through available description copy
        if (this.carouselIndex < this.description.length - 1) {
          this.carouselIndex++;
        } else {
          this.carouselIndex = 0;
        }

        this.isFinished = false;
      });
    },
    finishedTyping() {
      this.isFinished = true;

      // Wait 7s to switch to next description copy line
      setTimeout(() => {
        this.switchTypedContent();
      }, 7000);
    },
  },
});
</script>

<template>
  <div id="hero-container">
    <div class="hero-wrapper">
      <div class="hero-text">
        <div class="animation-wrapper">
          <SlpTypography
            v-if="header"
            :variant="isMobile ? 'body2' : 'heading5'"
            tag="h5"
            class="slp-mb-8 capitalize"
            >{{ header }}</SlpTypography
          >
          <SlpTypography variant="heading4-bold" tag="h4" class="note">{{
            note
          }}</SlpTypography>
        </div>
        <div
          class="typing-animation-wrapper"
          :class="{
            'typing-animation-wrapper__inline-description':
              selectedDescription.is_description_inline,
          }"
        >
          <SlpTypography
            tag="h1"
            variant="heading2-bold"
            :class="{
              'inline-description': selectedDescription.is_description_inline,
            }"
          >
            <TypingAnimation
              ref="typingAnimation"
              :text-array="selectedDescription.typed"
              :typing-delay="typingDelay"
              :new-line-delay="newLineDelay"
              :font-style="'alt'"
              @finished-typing="finishedTyping"
            />
          </SlpTypography>

          <span v-show="isFinished" class="highlighted-container">
            <SlpTypography
              tag="span"
              variant="heading2-bold"
              class="highlighted-text highlighted-animation"
              >{{ selectedDescription.highlighted }}</SlpTypography
            >
            <span
              class="suggestion-pill"
              :class="{
                'suggestion-pill--inline':
                  selectedDescription.is_description_inline,
              }"
            >
              <img
                src="/nuxt-images/icons/tanuki-code-suggestion.svg"
                alt="Tanuki icon"
              />
            </span>
          </span>
        </div>
        <div class="animation-wrapper button-container">
          <SlpButton
            :href="button.href"
            :variant="button.variant"
            :data-ga-name="button.data_ga_name"
            :data-ga-location="button.data_ga_location"
            >{{ button.text }}
            <SlpIcon v-if="button.icon" v-bind="button.icon" class="slp-ml-8"
          /></SlpButton>
          <SlpButton
            v-if="secondaryButton"
            class="secondary-button"
            :href="secondaryButton.href"
            :variant="secondaryButton.variant"
            >{{ secondaryButton.text }}
            <SlpIcon name="chevron-lg-right" variant="product"
          /></SlpButton>
        </div>
      </div>
      <div class="hero-image">
        <HeaderLogo :src="image.src" :alt="image.alt" />
      </div>
    </div>
  </div>
</template>

<style lang="scss" scoped>
#hero-container {
  margin: 160px 0;

  @media (max-width: $breakpoint-lg) {
    margin: $spacing-32 0 0 0;
  }
}

:deep .comment {
  color: $color-text-50;
}

.hero-wrapper {
  display: flex;
  align-items: center;
  justify-content: space-between;

  @media (max-width: $breakpoint-md) {
    flex-direction: column;
    gap: $spacing-32;

    & > * {
      min-width: 100% !important;
    }
  }

  @media (min-width: $breakpoint-md) {
    flex-direction: row;
    align-items: center;
    justify-content: space-between;
  }

  .hero-text {
    padding-top: $spacing-24;
    color: $color-text-50;

    @media (min-width: $breakpoint-md) {
      padding-top: 0;
    }

    @media (min-width: $breakpoint-lg) {
      max-width: 58%;
    }

    .animation-wrapper {
      @media (max-width: $breakpoint-md) {
        .slp-btn {
          width: 100%;
          justify-content: center;
        }
      }
    }

    .typing-animation-wrapper {
      font-size: 48px;
      margin-bottom: $spacing-16;
      min-height: 160px;

      &__inline-description {
        min-height: $spacing-96;
      }

      .highlighted-container {
        position: relative;

        .highlighted-text {
          box-sizing: border-box;
          position: relative;

          &::after {
            content: '|';
            position: absolute;
            right: -$spacing-8;
            opacity: 0;
            animation: blink-cursor 1s infinite;
          }
        }

        .highlighted-animation {
          animation:
            opacity-intro 6s step-start forwards,
            background-highlight 3s step-end,
            add-border-color 3s step-end,
            font-color 3s step-end forwards;
        }

        .suggestion-pill {
          animation: show-item-and-hide 6s step-start forwards;
          max-width: 32px;
          background: $color-accent-400;
          border-radius: 0px $spacing-4 $spacing-4 $spacing-4;
          margin-top: $spacing-8;
          padding: $spacing-8;
          color: $color-text-300;
          display: flex;
          align-items: center;
          justify-content: center;
          position: relative;

          &::before {
            content: '';
            position: absolute;
            top: -$spacing-16;
            left: 0;
            height: $spacing-16;
            border-left: 2px solid $color-accent-400;
          }

          &--inline {
            display: inline-flex;
            position: absolute;
            bottom: -40px;
            left: 0;
            max-height: $spacing-32;

            &::before {
              content: '';
              position: absolute;
              top: -$spacing-16;
              left: 0;
              border-left: 2px solid $color-accent-400;
            }
          }
        }
      }
    }

    .note {
      margin-bottom: $spacing-16;
      background: linear-gradient(
        90.05deg,
        #e1986d 2.53%,
        #7759c2 99.99%,
        #6e43d3 100%
      );
      -webkit-background-clip: text;
      -webkit-text-fill-color: transparent;
    }
  }

  .hero-image {
    opacity: 0;
    animation: opacity-intro 0.9s linear forwards 1.2s;
  }
}

.capitalize {
  text-transform: capitalize !important;
}

.inline-description {
  display: inline !important;
  & > * {
    display: inline !important;
  }
}

.button-container {
  display: flex;
  flex-direction: column;
  gap: 16px;
  @media (min-width: $breakpoint-lg) {
    flex-direction: row;
  }
}

.secondary-button {
  color: white;
}

@keyframes opacity-intro {
  from {
    opacity: 0;
  }
  to {
    opacity: 1;
  }
}
@keyframes font-color {
  from {
    color: $color-text-200;
  }

  to {
    color: $color-text-50 !important;
  }
}

@keyframes show-item-and-hide {
  0% {
    visibility: hidden;
  }
  50% {
    visibility: visible;
  }
  100% {
    visibility: hidden;
  }
}

@keyframes background-highlight {
  from {
    background-color: rgba(169, 137, 245, 0.2);
  }
  to {
    background-color: transparent;
  }
}

@keyframes add-border-color {
  from {
    border-left: 2px solid $color-accent-400;
  }
  to {
    border: none;
  }
}

@keyframes blink-cursor {
  to {
    opacity: 1;
  }
}
</style>
